/*
 * varargs.h cannot be portable...
 *
 */
#ifndef __CRIS__
#error This varargs.h is for gcc on the CRIS processor ONLY!
#else

#ifndef _VARARGS_H
#define _VARARGS_H

/* FIXME: We need to remove this file, as the real one in GCC should be
   used.  For now, include a copy of gcc/ginclude/varargs.h which we use
   for newer GCC.  */
#if !defined (__GNUC__) || !defined (__GNUC_MINOR__) || (__GNUC__ <= 2 && __GNUC_MINOR__ < 96)
#define __gnuc_va_list __va___list
#define va_list __va___list
#ifndef ___list
#define ___list
typedef void * __va___list;
#endif
#define va_alist __builtin_va_alist
/* Note that this will expand:
    foo(va_list)
       va_dcl;
    { stuff(); }
   into:
    foo(__builtin_va_alist)
       int __builtin_va_alist; ...
    { stuff(); }
   which isnt EXACTLY conforming to
   ANSI-C (you twit!)
*/
#define va_dcl int __builtin_va_alist; ...
/* Do all varargs/stdarg stuff here, and just #include this
   with _STDARG_H #defined from stdarg.h
*/

#ifdef _STDARG_H
# if (__GNUC__ >= 2) && (__GNUC_MINOR__ >= 6)
#  define va_start(AP, LASTARG)					\
  (AP = ((void *) __builtin_next_arg (LASTARG)))
# else
#  define va_start(AP, LASTARG)					\
  (AP = ((LASTARG),(void *) __builtin_next_arg ()))
# endif
#else
#define va_start(AP) 						\
 ((AP) = ((void *) &__builtin_va_alist))
#endif
#define va_end(list)

#define va_arg(list,TYPE) \
  __extension__ \
  ({ TYPE __va_temp;\
     /* Parameters larger than 32 bits are passed via reference. \
        Other parameters are passed with a FIXED SIZE of 32 bits, \
        i.e. they are promoted to int, or null-filled. */ \
     (sizeof(__va_temp) > sizeof(long)) \
       ? (__va_temp = **((TYPE **) (list))) \
	 : (__va_temp = *((TYPE *) (list))); ((long *) (list))++; \
   __va_temp;}) \

#else  /* GCC 2.96 or higher */

/* Copy of main part of gcc/ginclude/varargs.h follows verbatim.
   Please don't reformat, so diffing is simple.  */

/* These macros implement traditional (non-ANSI) varargs
   for GNU C.  */

#define va_alist  __builtin_va_alist

/* ??? We don't process attributes correctly in K&R argument context.  */
typedef int __builtin_va_alist_t __attribute__((__mode__(__word__)));

/* ??? It would be nice to get rid of the ellipsis here.  It causes
   current_function_varargs to be set in cc1.  */
#define va_dcl		__builtin_va_alist_t __builtin_va_alist; ...

/* Define __gnuc_va_list, just as in stdarg.h.  */

#ifndef __GNUC_VA_LIST
#define __GNUC_VA_LIST
typedef __builtin_va_list __gnuc_va_list;
#endif

#define va_start(v)	__builtin_varargs_start((v))
#define va_end		__builtin_va_end
#define va_arg		__builtin_va_arg
#define __va_copy(d,s)	__builtin_va_copy((d),(s))

/* Define va_list from __gnuc_va_list.  */

#ifdef _HIDDEN_VA_LIST  /* On OSF1, this means varargs.h is "half-loaded".  */
#undef _VA_LIST
#endif

#if defined(__svr4__) || (defined(_SCO_DS) && !defined(__VA_LIST))
/* SVR4.2 uses _VA_LIST for an internal alias for va_list,
   so we must avoid testing it and setting it here.
   SVR4 uses _VA_LIST as a flag in stdarg.h, but we should
   have no conflict with that.  */
#ifndef _VA_LIST_
#define _VA_LIST_
#ifdef __i860__
#ifndef _VA_LIST
#define _VA_LIST va_list
#endif
#endif /* __i860__ */
typedef __gnuc_va_list va_list;
#ifdef _SCO_DS
#define __VA_LIST
#endif
#endif /* _VA_LIST_ */

#else /* not __svr4__  || _SCO_DS */

/* The macro _VA_LIST_ is the same thing used by this file in Ultrix.
   But on BSD NET2 we must not test or define or undef it.
   (Note that the comments in NET 2's ansi.h
   are incorrect for _VA_LIST_--see stdio.h!)  */
/* Michael Eriksson <mer@sics.se> at Thu Sep 30 11:00:57 1993:
   Sequent defines _VA_LIST_ in <machine/machtypes.h> to be the type to
   use for va_list (``typedef _VA_LIST_ va_list'') */
#if !defined (_VA_LIST_) || defined (__BSD_NET2__) || defined (____386BSD____) || defined (__bsdi__) || defined (__sequent__) || defined (__FreeBSD__) || defined(WINNT)
/* The macro _VA_LIST_DEFINED is used in Windows NT 3.5  */
#ifndef _VA_LIST_DEFINED
/* The macro _VA_LIST is used in SCO Unix 3.2.  */
#ifndef _VA_LIST
/* The macro _VA_LIST_T_H is used in the Bull dpx2  */
#ifndef _VA_LIST_T_H
/* The macro __va_list__ is used by BeOS.  */
#ifndef __va_list__
typedef __gnuc_va_list va_list;
#endif /* not __va_list__ */
#endif /* not _VA_LIST_T_H */
#endif /* not _VA_LIST */
#endif /* not _VA_LIST_DEFINED */
#if !(defined (__BSD_NET2__) || defined (____386BSD____) || defined (__bsdi__) || defined (__sequent__) || defined (__FreeBSD__))
#define _VA_LIST_
#endif
#ifndef _VA_LIST
#define _VA_LIST
#endif
#ifndef _VA_LIST_DEFINED
#define _VA_LIST_DEFINED
#endif
#ifndef _VA_LIST_T_H
#define _VA_LIST_T_H
#endif
#ifndef __va_list__
#define __va_list__
#endif

#endif /* not _VA_LIST_, except on certain systems */

#endif /* not __svr4__ */

/* The next BSD release (if there is one) wants this symbol to be
   undefined instead of _VA_LIST_.  */
#ifdef _BSD_VA_LIST
#undef _BSD_VA_LIST
#endif
/* End of copy of gcc/ginclude/varargs.h */

#endif /* not _VARARGS_H */
#endif /* CRIS */
